<?php
/* RPG character poll
  Copyright (C) 1992,2007 Joel Yliluoma (http://iki.fi/bisqwit/)
*/

$attrs = Array
(
  'extrovert'   => Array
    (
      0 => 'You prefer to be left alone.',
    0.5 => '',
      1 => 'You prefer to be where all the people are.'
    ),
  'patience'    => Array
    (
      0 => 'You cannot concentrate on a thing.',
    0.5 => '',
      1 => 'You are very patient.'
    ),
  'reliance'    => Array
    (
      0 => 'You trust no-one.',
    0.5 => '',
      1 => 'You don\'t hesitate to ask for help.'
    ),
  'trustworth'  => Array
    (
      0 => 'Nobody trusts you.',
    0.5 => '',
      1 => 'People trust you.'
    ),
  'machinery'   => Array
    (
      0 => 'You are one with the nature.',
    0.5 => '',
      1 => 'You are a machinery geek.'
    ),
  'craft'       => Array
    (
      0 => '',
    0.5 => '',
      1 => 'You like hand-craft.'
    ),
  'killpower'   => Array
    (
      0 => '',
     0.5=> '',
      1 => 'You are a vigorous warrior.'
    ),
  'changepower' => Array
    (
      0 => 'You are lazy.',
    0.5 => '',
      1 => 'The world needs changing, and you are up to do it.'
    ),
  'gender'      => Array
    (
      0 => 'You think like a male.',
      0.5 => '',
      1 => 'You think like a female.'
    )
);

// TYPES: values are 0..100, not 0..1
// FIRST VALUE: average, SECOND VALUE: +-variation

$types = Array
(
  'Monk' => Array
  (
    'name' => 'Monk',
    'desc' => 'Your willpower is strong, and you do not need weapons to prove it.',
    'attrs' => GenAttrs('extrovert:40/20, patience:90/10, reliance:65/25'.
                      ', trustworth:70/20, killpower:40/10'.
                      ', changepower:20/10, gender:40/50, craft:60/10')
  ),
  
  'Archer F' => Array
  (
    'name' => 'Archer',
    'desc' => 'You prefer to shoot enemies from afar, and you have the patience to learn to do that.',
    'attrs' => GenAttrs('extrovert:0/30, patience:60/30, reliance:0/20'.
                      ', trustworth:0/20, machinery:10/60, killpower:40/20'.
                      ', changepower:20/10, gender:100/15, craft:60/10')
  ),
  
  'Archer M' => Array
  (
    'name' => 'Archer',
    'desc' => 'You prefer to shoot enemies from afar, and you have the patience to learn to do that.',
    'attrs' => GenAttrs('extrovert:60/10, patience:80/15, reliance:0/30'.
                      ', trustworth:90/10, machinery:10/60, killpower:40/20'.
                      ', changepower:40/25, gender:0/15, craft:60/10')
  ),
  
  'White mage' => Array
  (
    'name' => 'White mage',
    'desc' => 'You are a healer.',
    'attrs' => GenAttrs('extrovert:20/10, patience:80/20, reliance:70/20'.
                      ', trustworth:90/10, killpower:0/10'.
                      ', changepower:30/20, gender:100/70, craft:20/10')
  ),
  
  'Black mage' => Array
  (
    'name' => 'Black mage',
    'desc' => 'You solve your problems in a colourful fashion, without care for casualties.',
    'attrs' => GenAttrs('extrovert:0/30, patience:35/15, reliance:50/30'.
                      ', trustworth:0/30, machinery:10/40, killpower:90/30'.
                      ', changepower:70/30, gender:10/20, craft:20/10')
  ),

  'Thief' => Array
  (
    'name' => 'Thief',
    'desc' => 'No lock can prevent you from achieving your goal. But not everyone likes your goals...',
    'attrs' => GenAttrs('extrovert:20/60, patience:20/60, reliance:0/10'.
                      ', trustworth:0/10, machinery:70/20, killpower:20/10'.
                      ', changepower:0/10, craft:80/10')
  ),
  
  'Mimic' => Array
  (
    'name' => 'Mimic',
    'desc' => 'You are the perfect friend and the perfect foil at the same time. You just lack a bit of determination.',
    'attrs' => GenAttrs('extrovert:0/30, patience:90/20, reliance:50/10'.
                      ', trustworth:50/10, machinery:20/15, killpower:0/10'.
                      ', changepower:0/10, craft:50/10')
  ),

  'Summoner' => Array
  (
    'name' => 'Summoner',
    'desc' => 'You like to have strong friends.',
    'attrs' => GenAttrs('extrovert:70/30, patience:25/15, reliance:80/30'.
                      ', trustworth:40/30, machinery:40/10, killpower:60/10'.
                      ', changepower:50/10, gender:100/80, craft:15/5')
  ),

  'Swordsman' => Array
  (
    'name' => 'Swordsman',
    'desc' => 'Your own tools work the best.',
    'attrs' => GenAttrs('extrovert:40/20, patience:30/10, reliance:30/25'.
                      ', trustworth:30/10, machinery:60/40, killpower:80/20'.
                      ', changepower:20/8, gender:0/60, craft:80/10')
  ),
  
  'Paladin' => Array
  (
    'name' => 'Paladin / Knight',
    'desc' => 'You are the noblest kind of warrior there exists.',
    'attrs' => GenAttrs('extrovert:40/20, patience:50/10, reliance:30/25'.
                      ', trustworth:70/20, machinery:60/40, killpower:80/20'.
                      ', changepower:40/13, gender:0/60, craft:75/10')
  ),
  
  'Inventor' => Array
  (
    'name' => 'Inventor',
    'desc' => 'Any non-repetitive task is fine, as long as it involves using some tool you have designed yourself.',
    'attrs' => GenAttrs('extrovert:30/20, patience:70/40, reliance:60/20'.
                      ', trustworth:80/20, machinery:100/20, killpower:30/30'.
                      ', gender:40/40, craft:50/30')
  )
);

$relations = Array
(
  'Antagonist' => Array
  (
    'name' => 'Antagonist',
    'desc' => 'You could be the antagonist of the game, aiming to destroy the world.',
    'attrs' => GenAttrs('killpower:100/20, trustworth:0/20, reliance:0/20, changepower:100/20, gender:0/70')
  ),
  
  'Antasidekick' => Array
  (
    'name' => 'Minor antagonist',
    'desc' => 'You could be a henchman of the game\'s antagonist.',
    'attrs' => GenAttrs('killpower:80/20, trustworth:30/10, reliance:30/20')
  ),
  
  'Protagonist' => Array
  (
    'name' => 'Protagonist',
    'desc' => 'You could be the protagonist of the game, striving to save the world.',
    'attrs' => GenAttrs('changepower:100/20, trustworth:100/30, reliance:100/40, extrovert:100/30')
  ),
  
  'Protasidekick' => Array
  (
    'name' => 'Minor protagonist',
    'desc' => 'You could be a friend of the protagonist of the game, striving to save the world.',
    'attrs' => GenAttrs('changepower:60/10, trustworth:100/30, reliance:100/40')
  ),
  
  'NPC' => Array
  (
    'name' => 'An NPC',
    'desc' => 'You could be anyone in the game, but nobody important.',
    'attrs' => GenAttrs('killpower:50/1, trustworth:50/1')
  )
);

function GenAttrs($attrstr)
{
  $res = Array();
  foreach(split(", *", $attrstr) as $attrstr)
  {
    preg_match('@(.*):(.*?)/(.*)@', $attrstr, $mat);
    
    $avg  = $mat[2] / 100.0;
    $dist = $mat[3] / 100.0;
    
    $res[$mat[1]] = Array('min'=>max(0, $avg-$dist),
                          'max'=>min(100, $avg+$dist),
                          'avg'=>$avg,
                          'dist'=>$dist
                         );
  }
  return $res;
}
